Public NotInheritable Class CloseButton
    Private Declare Function GetSystemMenu Lib "user32" _
        (ByVal hWnd As IntPtr, ByVal bRevert As Integer) As IntPtr
    Private Declare Function GetMenuState Lib "user32" _
        (ByVal hMenu As IntPtr, ByVal uId As Integer, _
            ByVal uFlags As Integer) As Integer
    Private Declare Function EnableMenuItem Lib "user32" _
        (ByVal hMenu As IntPtr, ByVal wIDEnableItem As Integer, _
            ByVal wEnable As Integer) As Integer

    Private Const MF_ENABLED As Integer = &H0
    Private Const MF_DISABLED As Integer = &H2
    Private Const SC_CLOSE As Integer = &HF060

    Public Shared Property Enabled(ByVal form As Form) As Boolean
        Get
            Return CloseButton.IsEnabled(form)
        End Get
        Set(ByVal value As Boolean)
            CloseButton.ChangeState(form, value)
        End Set
    End Property

    Private Shared Function IsEnabled(ByVal form As Form) As Boolean
        Dim systemMenu As IntPtr = GetSystemMenu(form.Handle, 0)
        Dim state As Integer = GetMenuState(systemMenu, SC_CLOSE, 0)
        If (state And MF_DISABLED) = MF_DISABLED Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Shared Sub ChangeState(ByVal form As Form, ByVal state As Boolean)
        Dim systemMenu As IntPtr = GetSystemMenu(form.Handle, 0)
        Dim flag As Integer
        If state Then
            flag = MF_ENABLED
        Else
            flag = MF_DISABLED
        End If
        EnableMenuItem(systemMenu, SC_CLOSE, flag)
    End Sub
End Class
